#!/user/bin/env groovy

library identifier: 'jen-shared@main', retriever: modernSCM(
    [$class: 'GitSCMSource',
    remote: 'https://gitlab.com/_alucard/jen-shared.git',
    credentialsId: 'gitlab'
    ]
)


def gv

pipeline {
    agent any
    tools {
        maven 'Maven'
    }

       
    stages {
        stage("init") {
            steps {
                script {
                    gv = load "script.groovy"

                }
            }
        }

        stage("increment version") {
            steps {
                script {
                    incImage()
                    def matcher = readFile('pom.xml') =~ '<version>(.+)</version>'
                    def version = matcher[0][1]
                    env.IMAGE_NAME = "$version-$BUILD_NUMBER"

                }
            }
        }

        stage("build jar") {
            steps {
                script {
                    buildJar()
                }
            }
        }

        stage("build image") {
            steps {
                script {
                    buildImage(IMAGE_NAME)
                    dockerLogin()
                    dockerPush(IMAGE_NAME)
                }
            }
        }

        stage("terrform") {
            environment {
                AWS_ACCESS_KEY_ID = credentials('a')
                AWS_SECRET_ACCESS_KEY = credentials('b')
                TF_VAR_env_prefix = 'test'
            }
            steps {
                script {
                    dir('terraform') {
                        sh "terraform init"
                        sh "terraform apply --auto-approve"
                        EC2_PUBLIC_IP = sh(
                            script: "terraform output ec2_public_ip",
                            returnStdout: true
                        ).trim()
                    }
                }
            }


        }

        stage("deploy") {
            environment {
                CREDS = credentials('nexus')
            }
            steps {
                script {
                    echo "waitingggggggggg"
                    sleep(time: 10, unit: "SECONDS")

                    echo "${EC2_PUBLIC_IP}"

                    def shellCmd = "bash ./server-cmds.sh ${IMAGE_NAME} ${CREDS_USR} ${CREDS_PSW}"
                    def ec2Instance = "ec2-user@${EC2_PUBLIC_IP}"

                    sshagent(['server-ssh-key']) {
                        sh "scp -o StrictHostKeyChecking=no server-cmds.sh ${ec2Instance}:/home/ec2-user"
                        sh "scp -o StrictHostKeyChecking=no docker-compose.yaml ${ec2Instance}:/home/ec2-user"
                        sh "ssh -o StrictHostKeyChecking=no ${ec2Instance} ${shellCmd}"
                        
                    }
                }
            }
        }


        stage("commit version update") {
            steps {
                script {
                    gv.pushPomFile()

                    }
                }
            }
        
    }
    
}

